OpenVDB: InternalNode< _ChildNodeType, Log2Dim >::ValueIter< NodeT, ValueT, MaskIterT, TagT > Struct Template Reference

OpenVDB 4.0.2

Public Types | Public Member Functions | Static Public Attributes | List of all members
InternalNode< _ChildNodeType, Log2Dim >::ValueIter< NodeT, ValueT, MaskIterT, TagT > Struct Template Reference

`#include <InternalNode.h>`

Inherits SparseIteratorBase< MaskIterT, ValueIter< NodeT, ValueT, MaskIterT, TagT >, NodeT, ValueT >.

## Public Types
typedef NodeT | NodeType
typedef ValueT | ValueType
typedef boost::remove_const< NodeT >::type | NonConstNodeType
typedef boost::remove_const< ValueT >::type | NonConstValueType

## Public Member Functions
| ValueIter ()
| ValueIter (const MaskIterT &iter, NodeT *parent)
const ValueT & | getItem (Index pos) const
void | setItem (Index pos, const ValueT &v) const
template<typename ModifyOp >
void | modifyItem (Index pos, const ModifyOp &op) const
ValueT & | operator* () const
| Return a reference to the item to which this iterator is pointing. More...
ValueT * | operator-> () const
| Return a pointer to the item to which this iterator is pointing. More...
ValueT & | getValue () const
| Return the item to which this iterator is pointing. More...
void | setValue (const ValueT &value) const
| Set the value of the item to which this iterator is pointing. (Not valid for const iterators.) More...
void | modifyValue (const ModifyOp &op) const
| Apply a functor to the item to which this iterator is pointing. (Not valid for const iterators.) More...
bool | operator== (const IteratorBase &other) const
bool | operator!= (const IteratorBase &other) const
NodeT * | getParentNode () const
| Return a pointer to the node (if any) over which this iterator is iterating. More...
NodeT & | parent () const
| Return a reference to the node over which this iterator is iterating. More...
Index | offset () const
| Return this iterator's position as an index into the parent node's table. More...
Index | pos () const
| Identical to offset. More...
bool | test () const
| Return `true` if this iterator is not yet exhausted. More...
| operator bool () const
| Return `true` if this iterator is not yet exhausted. More...
bool | next ()
| Advance to the next item in the parent node's table. More...
void | increment ()
| Advance to the next item in the parent node's table. More...
void | increment (Index n)
| Advance n items in the parent node's table. More...
IteratorBase & | operator++ ()
| Advance to the next item in the parent node's table. More...
bool | isValueOn () const
| Return `true` if this iterator is pointing to an active value. Return `false` if it is pointing to either an inactive value or a child node. More...
void | setValueOn (bool on=true) const
| If this iterator is pointing to a value, set the value's active state. Otherwise, do nothing. More...
void | setValueOff () const
| If this iterator is pointing to a value, mark the value as inactive. More...
Coord | getCoord () const
| Return the coordinates of the item to which this iterator is pointing. More...
void | getCoord (Coord &xyz) const
| Return in xyz the coordinates of the item to which this iterator is pointing. More...

## Static Public Attributes
static const bool | IsSparseIterator
static const bool | IsDenseIterator

## Member Typedef Documentation

## ◆ NodeType

typedef NodeT NodeType
| inherited

## ◆ NonConstNodeType

typedef boost::remove_const<NodeT>::type NonConstNodeType
| inherited

## ◆ NonConstValueType

typedef boost::remove_const<ValueT >::type NonConstValueType
| inherited

## ◆ ValueType

typedef ValueT ValueType
| inherited

## Constructor & Destructor Documentation

## ◆ ValueIter() [1/2]

ValueIter | ( |  | ) |
| inline

## ◆ ValueIter() [2/2]

ValueIter | ( | const MaskIterT & | iter,
|  | NodeT * | parent
| ) |  |
| inline

## Member Function Documentation

## ◆ getCoord() [1/2]

Coord getCoord | ( |  | ) | const
| inlineinherited

Return the coordinates of the item to which this iterator is pointing.

## ◆ getCoord() [2/2]

void getCoord | ( | Coord & | xyz | ) | const
| inlineinherited

Return in xyz the coordinates of the item to which this iterator is pointing.

## ◆ getItem()

const ValueT& getItem | ( | Index | pos | ) | const
| inline

## ◆ getParentNode()

NodeT* getParentNode | ( |  | ) | const
| inlineinherited

Return a pointer to the node (if any) over which this iterator is iterating.

## ◆ getValue()

ValueT & getValue | ( |  | ) | const
| inlineinherited

Return the item to which this iterator is pointing.

## ◆ increment() [1/2]

void increment | ( |  | ) |
| inlineinherited

Advance to the next item in the parent node's table.

## ◆ increment() [2/2]

void increment | ( | Index | n | ) |
| inlineinherited

Advance n items in the parent node's table.

## ◆ isValueOn()

bool isValueOn | ( |  | ) | const
| inlineinherited

Return `true` if this iterator is pointing to an active value. Return `false` if it is pointing to either an inactive value or a child node.

## ◆ modifyItem()

void modifyItem | ( | Index | pos,
|  | const ModifyOp & | op
| ) |  | const
| inline

## ◆ modifyValue()

void modifyValue | ( | const ModifyOp & | op | ) | const
| inlineinherited

Apply a functor to the item to which this iterator is pointing. (Not valid for const iterators.)

Parameters

  op | a functor of the form `void op(ValueType&) const` that modifies its argument in place

See also
  Tree::modifyValue()

## ◆ next()

bool next | ( |  | ) |
| inlineinherited

Advance to the next item in the parent node's table.

## ◆ offset()

Index offset | ( |  | ) | const
| inlineinherited

Return this iterator's position as an index into the parent node's table.

## ◆ operator bool()

operator bool | ( |  | ) | const
| inlineinherited

Return `true` if this iterator is not yet exhausted.

## ◆ operator!=()

bool operator!= | ( | const IteratorBase< MaskIterT, NodeT > & | other | ) | const
| inlineinherited

## ◆ operator*()

ValueT & operator* | ( |  | ) | const
| inlineinherited

Return a reference to the item to which this iterator is pointing.

## ◆ operator++()

IteratorBase& operator++ | ( |  | ) |
| inlineinherited

Advance to the next item in the parent node's table.

## ◆ operator->()

ValueT * operator-> | ( |  | ) | const
| inlineinherited

Return a pointer to the item to which this iterator is pointing.

## ◆ operator==()

bool operator== | ( | const IteratorBase< MaskIterT, NodeT > & | other | ) | const
| inlineinherited

## ◆ parent()

NodeT& parent | ( |  | ) | const
| inlineinherited

Return a reference to the node over which this iterator is iterating.

Exceptions

  ValueError | if there is no parent node.

## ◆ pos()

Index pos | ( |  | ) | const
| inlineinherited

Identical to offset.

## ◆ setItem()

void setItem | ( | Index | pos,
|  | const ValueT & | v
| ) |  | const
| inline

## ◆ setValue()

void setValue | ( | const ValueT & | value | ) | const
| inlineinherited

Set the value of the item to which this iterator is pointing. (Not valid for const iterators.)

## ◆ setValueOff()

void setValueOff | ( |  | ) | const
| inlineinherited

If this iterator is pointing to a value, mark the value as inactive.

If this iterator is pointing to a child node, then the current item in the parent node's table is required to be inactive. In that case, this method has no effect.

## ◆ setValueOn()

void setValueOn | ( | bool | on = `true` | ) | const
| inlineinherited

If this iterator is pointing to a value, set the value's active state. Otherwise, do nothing.

## ◆ test()

bool test | ( |  | ) | const
| inlineinherited

Return `true` if this iterator is not yet exhausted.

## Member Data Documentation

## ◆ IsDenseIterator

const bool IsDenseIterator
| staticinherited

## ◆ IsSparseIterator

const bool IsSparseIterator
| staticinherited

The documentation for this struct was generated from the following file:

- InternalNode.h